

int ENB=11;      //Declara el pin digital 11 (válido para señales PWM) como ENB
int IN3=2;         //Declara el pin digital 2 como IN3
int IN4=4;         //Declara el pin digital 4 como IN4
int tv9AH=2390;    //Tiempo a velocidad 9 para 1 vuelta AntiHoraria
int tv9H=2610;      //Tiempo a velocidad 9 para 1 vuelta Horaria
int tv4AH=3490;       //Tiempo a velocidad 4 para 1 vuelta Anti Horaria
int tv4H=3570;       //Tiempo a velocidad 4 para 1 vuelta Horaria
int tv7AH=2708;       //Tiempo a velocidad 7 para 1 vuelta Anti Horaria
int tv7H=2960;      //Tiempo a velocidad 7 para 1 vuelta Horaria

int veces=0;
void setup() {
  Serial.begin(9600);      //Inicia la comunicación mediante el puerto Serie USB  a 9600 baudios
  Serial.println("Se necesitan los datos de inicialización del mecanismo"); //Muestra  por la pantalla del ordenador el mensaje
  Serial.println("Longitud del dedo meñique: 6, 4 o 3(cm)");
  Serial.println("Elija velocidad de trabajo, introduciendo 4 para lenta, 7 para media, y 9 para rápida");  
  Serial.println("Número de ciclos de apertura y cierre de la mano a realizar entre 1 y 9");
  Serial.println("Introducir con el formato: distancia,velocidad,ciclos");    

  pinMode(IN3, OUTPUT);      //Declara el pin IN3 (pin digital 2) como SALIDA
  pinMode(IN4, OUTPUT);      //Declara el pin IN4 (pin digital 4) como SALIDA
  pinMode(ENB, OUTPUT);    //Declara el pin ENB (pin digital 11) como SALIDA
 ;
}

void loop() {

  if (Serial.available()){                             // Si hay algun valor en la Consola Serial
      String vbles=Serial.readString();
      char ldedo=vbles.charAt(0);
      char velocidad=vbles.charAt(1);
      char ciclos=vbles.charAt(2);
      Serial.println(vbles);
      Serial.println("Longitud del dedo meñique");
      Serial.println(ldedo);
      Serial.println("velocidad");
      Serial.println(velocidad);
      Serial.println("ciclos");
      Serial.println(ciclos);
      int veces=ciclos-'0';   
      int vel = map(velocidad,'0','9',0,255);
           if (ciclos ==0){
               Serial.println("número de ciclos no válido");      
              }
               else{
                  if (velocidad>='0' && velocidad<='9')// Si el caracter ingresado esta entre 0 y 9
                      {                      
                      if(velocidad == '9')
                      {
                          if(ldedo == '6')
                            {
                              for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv9AH);
                                  } 
                            }
                            else if(ldedo == '4')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv9AH*0.23);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv9H*0.23);
                                  }
                              }
                            else if(ldedo == '3')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv9AH*0.2);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv9H*0.2);
                                  }
                              }
                              else {
                               Serial.println("longitud dedo meñique no válida");
                              }
                      }
                      else if(velocidad == '7')
                        {
                         if(ldedo == '6')
                            {
                              for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv7AH);
                                  } 
                            }
                            else if(ldedo == '4')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv7AH*0.23);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv7H*0.23);
                                  }          
                              }
                            else if(ldedo == '3')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv7AH*0.2);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv7H*0.2);
                                  }                               
                              }  
                              else {
                               Serial.println("longitud dedo meñique no válida");
                              }
                        }
                        else if(velocidad == '4')
                        {
                          if(ldedo == '6')
                            {
                              for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv4AH);
                                  } 
                            }
                            else if(ldedo == '4')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv4AH*0.23);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv4H*0.23);
                                  }  
                              }
                            else if(ldedo == '3')
                              {
                                 for(int i=1; i<=veces; i++)
                                  {
                                    digitalWrite(IN3, false);
                                    digitalWrite(IN4, true);               
                                    analogWrite(ENB, vel);
                                    delay(tv4AH*0.2);
                                    digitalWrite(IN3, true);
                                    digitalWrite(IN4, false);
                                    delay(tv4H*0.2);
                                  }
                              }  
                              else {
                               Serial.println("longitud dedo meñique no válida");
                              }                                                
                      } 
                   else { 
                          Serial.println("Velocidad no válida");
                         }
               }
              digitalWrite(IN3, false);
              digitalWrite(IN4, false);
  }
}
}
